<script lang="ts">
  import type { PlayerId, State } from "../../server";
  import CardFront from "../CardFront.svelte";
  import { createActionDispatcher } from "../util/createActionDispatcher";

  const dispatchAction = createActionDispatcher();

  export let state: State;
  const players = state.players;
  const phase = state.phase as {
    kind: "CompareComplete";
    actor: PlayerId;
    actor_ready: boolean;
    target: PlayerId;
    target_ready: boolean;
  };
  export let actorId: PlayerId;

  $: target = phase.target;
  $: target_ready = phase.target_ready;
  $: actor = phase.actor;
  $: actor_ready = phase.actor_ready;

  $: actorCard = players.find((player) => player.id === actor)?.hand[0];
  $: targetCard = players.find((player) => player.id === target)?.hand[0];

  $: ready =
    (actorId === target && target_ready) || (actorId === actor && actor_ready);
</script>

<section>
  <h3>Comparing cards</h3>
  <div class="players">
    <div class="player">
      <gs6-user playerid={actor} />
      {#if actorCard !== undefined}
        <div class="card">
          <CardFront card={actorCard} />
        </div>
      {/if}
    </div>
    <div class="player">
      <gs6-user playerid={target} />
      {#if targetCard !== undefined}
        <div class="card">
          <CardFront card={targetCard} />
        </div>
      {/if}
    </div>
  </div>

  {#if !ready}
    <button
      class="primary"
      on:click={() => dispatchAction({ kind: "CompareComplete" })}
    >
      OK
    </button>
  {/if}
</section>

<style>
  section {
    display: flex;
    flex-direction: column;
    align-items: center;
  }
  .players {
    display: flex;
    flex-direction: row;
    margin-block-end: 0.5em;
  }
  .player {
    margin: 0.5em;
    text-align: center;
    display: flex;
    flex-direction: column;
    align-items: center;
  }
  .card {
    margin-block-start: 0.5em;
  }
</style>
